﻿using System;
using System.Data;
using System.Collections.Generic;
using DTcms.Common;
using DTcms.Web.Plugin.ArticlePublish.Model;
namespace DTcms.Web.Plugin.ArticlePublish.BLL
{
    /// <summary>
    /// article_publish_category
    /// </summary>
    public partial class article_publish_category
    {
        private readonly DTcms.Model.siteconfig siteConfig = new DTcms.BLL.siteconfig().loadConfig(); //获得站点配置信息
        private readonly DTcms.Web.Plugin.ArticlePublish.DAL.article_publish_category dal;

        public article_publish_category()
        {
            dal = new DAL.article_publish_category(siteConfig.sysdatabaseprefix);
        }

        #region  BasicMethod

        /// <summary>
        /// 得到最大ID
        /// </summary>
        public int GetMaxId()
        {
            return dal.GetMaxId();
        }

        /// <summary>
        /// 是否存在该记录
        /// </summary>
        public bool Exists(int id)
        {
            return dal.Exists(id);
        }

        /// <summary>
        /// 增加一条数据
        /// </summary>
        public int Add(DTcms.Web.Plugin.ArticlePublish.Model.article_publish_category model)
        {
            return dal.Add(model);
        }

        /// <summary>
        /// 更新一条数据
        /// </summary>
        public bool Update(DTcms.Web.Plugin.ArticlePublish.Model.article_publish_category model)
        {
            return dal.Update(model);
        }

        /// <summary>
        /// 修改一列数据
        /// </summary>
        public void UpdateField(int id, string strValue)
        {
            dal.UpdateField(id, strValue);
        }

        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool Delete(int id)
        {

            return dal.Delete(id);
        }

        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public DTcms.Web.Plugin.ArticlePublish.Model.article_publish_category GetModel(int id)
        {

            return dal.GetModel(id);
        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetList(string strWhere)
        {
            return dal.GetList(strWhere);
        }

        /// <summary>
        /// 获得前几行数据
        /// </summary>
        public DataSet GetList(int Top, string strWhere, string filedOrder)
        {
            return dal.GetList(Top, strWhere, filedOrder);
        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public List<DTcms.Web.Plugin.ArticlePublish.Model.article_publish_category> GetModelList(string strWhere)
        {
            DataSet ds = dal.GetList(strWhere);
            return DataTableToList(ds.Tables[0]);
        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public List<DTcms.Web.Plugin.ArticlePublish.Model.article_publish_category> DataTableToList(DataTable dt)
        {
            List<DTcms.Web.Plugin.ArticlePublish.Model.article_publish_category> modelList = new List<DTcms.Web.Plugin.ArticlePublish.Model.article_publish_category>();
            int rowsCount = dt.Rows.Count;
            if (rowsCount > 0)
            {
                DTcms.Web.Plugin.ArticlePublish.Model.article_publish_category model;
                for (int n = 0; n < rowsCount; n++)
                {
                    model = dal.DataRowToModel(dt.Rows[n]);
                    if (model != null)
                    {
                        modelList.Add(model);
                    }
                }
            }
            return modelList;
        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetAllList()
        {
            return GetList("");
        }

        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public int GetRecordCount(string strWhere)
        {
            return dal.GetRecordCount(strWhere);
        }

        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public DataSet GetListByPage(string strWhere, string orderby, int startIndex, int endIndex)
        {
            return dal.GetListByPage(strWhere, orderby, startIndex, endIndex);
        }
        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        //public DataSet GetList(int PageSize,int PageIndex,string strWhere)
        //{
        //return dal.GetList(PageSize,PageIndex,strWhere);
        //}

        #endregion  BasicMethod
        #region  ExtensionMethod
        /// <summary>
        /// 同步网站频道和网站类别到article_publish_category
        /// </summary>
        public void SynchronousDataToArticlePublishCategory()
        {
            int default_site_id = 0;
            //先获取默认站点
            DataSet ds_site = new DTcms.BLL.channel_site().GetList(0, "is_default=1", "id");
            if (ds_site != null)
            {
                default_site_id = int.Parse(ds_site.Tables[0].Rows[0]["id"].ToString());

                //获取默认站点下所有频道
                DataSet ds_channel = new DTcms.BLL.channel().GetList(0, "site_id=" + default_site_id, "sort_id");
                if (ds_channel != null || ds_channel.Tables[0] != null)
                {
                    //如果频道不为空，创建一个DataTable
                    DataTable newData = new DataTable();
                    newData.Columns.Add("channel_id", typeof(int));
                    newData.Columns.Add("category_id", typeof(int));
                    newData.Columns.Add("is_allow", typeof(int));
                    newData.Columns.Add("allow_usergroupid_list", typeof(string));

                    #region 将频道和栏目数据装入DataTable
                    foreach (DataRow dr in ds_channel.Tables[0].Rows)
                    {
                        DataRow newRow;
                        newRow = newData.NewRow();
                        newRow["channel_id"] = dr["id"];
                        newRow["category_id"] = 0;
                        newRow["is_allow"] = 0;
                        newRow["allow_usergroupid_list"] = ",";
                        newData.Rows.Add(newRow);

                        DataTable dt_category = new DTcms.BLL.article_category().GetList(0, int.Parse(dr["id"].ToString()));
                        foreach (DataRow drc in dt_category.Rows)
                        {
                            newRow = newData.NewRow();
                            newRow["channel_id"] = dr["id"];
                            newRow["category_id"] = drc["id"];
                            newRow["is_allow"] = 0;
                            newRow["allow_usergroupid_list"] = ",";
                            newData.Rows.Add(newRow);
                        }
                    }
                    #endregion

                    //查询article_publish_category并进行比较。
                    DataSet ds = GetAllList();

                    if (ds == null || ds.Tables[0].Rows.Count == 0) //第一次写入数据
                    {
                        foreach (DataRow drw in newData.Rows)
                        {
                            Model.article_publish_category model = new Model.article_publish_category();
                            model.category_id = int.Parse(drw["category_id"].ToString());
                            model.channel_id = int.Parse(drw["channel_id"].ToString());
                            model.is_allow = 0;
                            model.allow_usergroupid_list = ",";
                            Add(model);
                        }
                    }
                    else //如果数据有变化则进行调整
                    {
                        #region 数据比较
                        //if (ds.Tables[0].Rows.Count < newData.Rows.Count) //新增了类别后的处理
                        //{
                        //    foreach (DataRow dr1 in newData.Rows)
                        //    {
                        //        int count = 0;
                        //        foreach (DataRow dr2 in ds.Tables[0].Rows)
                        //        {
                        //            if (dr1["channel_id"].ToString() == dr2["channel_id"].ToString() && dr1["category_id"].ToString() == dr2["category_id"].ToString())
                        //            {
                        //                count = 1; //发现有相同的类别
                        //            }
                        //        }
                        //        if (count < 1)
                        //        {
                        //            Model.article_publish_category model = new Model.article_publish_category();
                        //            model.category_id = int.Parse(dr1["category_id"].ToString());
                        //            model.channel_id = int.Parse(dr1["channel_id"].ToString());
                        //            model.is_allow = 0;
                        //            model.allow_usergroupid_list = ",";
                        //            Add(model);
                        //        }
                        //    }
                        //}
                        //else if (ds.Tables[0].Rows.Count > newData.Rows.Count) //删除了类别后的处理
                        //{
                        //    foreach (DataRow dr1 in ds.Tables[0].Rows)
                        //    {
                        //        int count = 0;
                        //        foreach (DataRow dr2 in newData.Rows)
                        //        {
                        //            if (dr1["channel_id"].ToString() == dr2["channel_id"].ToString() && dr1["category_id"].ToString() == dr2["category_id"].ToString())
                        //            {
                        //                count = 1; //发现有相同的类别
                        //            }
                        //        }
                        //        if (count < 1)
                        //        {
                        //            Delete(int.Parse(dr1["id"].ToString()));
                        //        }
                        //    }
                        //}
                        //else
                        //{ }
                        #endregion



                        #region 数据比较新版
                        //第一轮，比较类别，添加没有的数据
                        foreach (DataRow dr1 in newData.Rows)  
                        {
                            int count = 0;
                            foreach (DataRow dr2 in ds.Tables[0].Rows)
                            {
                                if (dr1["channel_id"].ToString() == dr2["channel_id"].ToString() && dr1["category_id"].ToString() == dr2["category_id"].ToString())
                                {
                                    count = 1; //发现有相同的类别
                                }
                            }
                            if (count < 1)
                            {
                                Model.article_publish_category model = new Model.article_publish_category();
                                model.category_id = int.Parse(dr1["category_id"].ToString());
                                model.channel_id = int.Parse(dr1["channel_id"].ToString());
                                model.is_allow = 0;
                                model.allow_usergroupid_list = ",";
                                Add(model);
                            }
                        }
                        //第二轮，比较类别，删除多余数据
                        foreach (DataRow dr1 in ds.Tables[0].Rows)
                        {
                            int count = 0;
                            foreach (DataRow dr2 in newData.Rows)
                            {
                                if (dr1["channel_id"].ToString() == dr2["channel_id"].ToString() && dr1["category_id"].ToString() == dr2["category_id"].ToString())
                                {
                                    count = 1; //发现有相同的类别
                                }
                            }
                            if (count < 1)
                            {
                                Delete(int.Parse(dr1["id"].ToString()));
                            }
                        }
                        #endregion
                    }

                }
            }
        }

        /// <summary>
        /// 获取可发布的频道列表
        /// </summary>
        public DataTable GetPubChannelList(int usergroupid)
        {
            DataTable newData = new DataTable();
            newData.Columns.Add("id", typeof(int));
            newData.Columns.Add("title", typeof(string));
            DataSet ds = GetList("category_id=0 and is_allow=1 and allow_usergroupid_list like '%," + usergroupid + ",%'");
            if (ds.Tables[0].Rows.Count > 0)
            {
                #region 遍历设置值
                DataTable dt = new DTcms.BLL.channel().GetList(0, "", "sort_id").Tables[0];
                foreach (DataRow dr in dt.Rows)
                {
                    bool isallow = false;
                    foreach (DataRow drc in ds.Tables[0].Rows)
                    {
                        if (drc["channel_id"].ToString() == dr["id"].ToString())
                        {
                            isallow = true;
                        }
                    }
                    if (isallow)
                    {
                        DataRow newRow;
                        newRow = newData.NewRow();
                        newRow["id"] = dr["id"].ToString();
                        newRow["title"] = dr["title"].ToString();
                        newData.Rows.Add(newRow);
                    }
                }
                #endregion
            }
            return newData;
        }

        /// <summary>
        /// 获取可发布的栏目列表
        /// </summary>
        public DataTable GetPubCategoryList(int usergroupid,int channel_id)
        {
            DataTable newData = new DataTable();
            newData.Columns.Add("id", typeof(int));
            newData.Columns.Add("title", typeof(string));
            newData.Columns.Add("class_layer", typeof(int));
            DataSet ds = GetList("is_allow=1 and allow_usergroupid_list like '%," + usergroupid + ",%' and channel_id="+ channel_id);
            if (ds.Tables[0].Rows.Count > 0)
            {
                #region 遍历设置值
                DataTable dt = new DTcms.BLL.article_category().GetList(0,channel_id);
                foreach (DataRow dr in dt.Rows)
                {
                    bool isallow = false;
                    foreach (DataRow drc in ds.Tables[0].Rows)
                    {
                        if (drc["category_id"].ToString() == dr["id"].ToString())
                        {
                            isallow = true;
                        }
                    }
                    if (isallow)
                    {
                        DataRow newRow;
                        newRow = newData.NewRow();
                        newRow["id"] = dr["id"].ToString();
                        newRow["title"] = dr["title"].ToString();
                        newRow["class_layer"] = dr["class_layer"].ToString();
                        newData.Rows.Add(newRow);
                    }
                }
                #endregion
            }
            return newData;
        }

        /// <summary>
        /// 获取网站栏目和类别的属性
        /// </summary>
        public DataTable GetAllListAndGetProperty()
        {
            //如果频道不为空，创建一个DataTable
            DataTable oldData = new DataTable();
            oldData.Columns.Add("id", typeof(int));
            oldData.Columns.Add("channel_id", typeof(int));
            oldData.Columns.Add("parent_id", typeof(int));
            oldData.Columns.Add("category_id", typeof(int));
            oldData.Columns.Add("layer", typeof(int));
            oldData.Columns.Add("title", typeof(string));
            oldData.Columns.Add("sort_id", typeof(int));
            oldData.Columns.Add("is_allow", typeof(int));
            oldData.Columns.Add("allow_usergroupid_list", typeof(string));
            oldData.Columns.Add("allow_usergroupname_list", typeof(string));

            DataSet ds = GetAllList();
            if (ds.Tables[0].Rows.Count > 0)
            {
                #region 遍历设置值
                foreach (DataRow dr in ds.Tables[0].Rows)
                {
                    if (int.Parse(dr["category_id"].ToString()) == 0) //设置频道
                    {
                        DTcms.Model.channel model = new DTcms.BLL.channel().GetModel(int.Parse(dr["channel_id"].ToString()));
                        DataRow newRow;
                        newRow = oldData.NewRow();
                        newRow["id"] = dr["id"].ToString();
                        newRow["channel_id"] = dr["channel_id"].ToString();
                        newRow["parent_id"] = 0;
                        newRow["category_id"] = 0;
                        newRow["layer"] = 0;
                        newRow["title"] = model.title;
                        newRow["sort_id"] = model.sort_id;
                        newRow["is_allow"] = dr["is_allow"].ToString();
                        newRow["allow_usergroupid_list"] = dr["allow_usergroupid_list"].ToString();
                        newRow["allow_usergroupname_list"] = GetUserGroupNameList(dr["allow_usergroupid_list"].ToString());
                        oldData.Rows.Add(newRow);
                    }
                    else //设置类别
                    {
                        DTcms.Model.article_category model = new DTcms.BLL.article_category().GetModel(int.Parse(dr["category_id"].ToString()));
                        DataRow newRow;
                        newRow = oldData.NewRow();
                        newRow["id"] = dr["id"].ToString();
                        newRow["channel_id"] = dr["channel_id"].ToString();
                        newRow["parent_id"] = model.parent_id;
                        newRow["category_id"] = dr["category_id"].ToString();
                        newRow["layer"] = model.class_layer;
                        newRow["title"] = model.title;
                        newRow["sort_id"] = model.sort_id;
                        newRow["is_allow"] = dr["is_allow"].ToString();
                        newRow["allow_usergroupid_list"] = dr["allow_usergroupid_list"].ToString();
                        newRow["allow_usergroupname_list"] = GetUserGroupNameList(dr["allow_usergroupid_list"].ToString());
                        oldData.Rows.Add(newRow);
                    }
                }
                #endregion
            }


            //复制结构
            DataTable newData = oldData.Clone();
            //调用迭代组合成DAGATABLE
            GetChilds(oldData, newData, 0, 0, 0);
            return newData;

        }

        /// <summary>
        /// 获取需操作类别的子ID列表
        /// </summary>
        public List<int> GetChildIDList(int id)
        {
            List<int> childid = new List<int>();
            Model.article_publish_category model = new BLL.article_publish_category().GetModel(id);
            DataTable dt = new DTcms.BLL.article_category().GetList(model.category_id, model.channel_id);
            DataSet ds = new BLL.article_publish_category().GetAllList();

            if (dt != null && dt.Rows.Count > 0)
            {
                foreach (DataRow dr in dt.Rows)
                {
                    foreach (DataRow drc in ds.Tables[0].Rows)
                    {
                        if (dr["channel_id"].ToString() == drc["channel_id"].ToString() && dr["id"].ToString() == drc["category_id"].ToString())
                        {
                            childid.Add(int.Parse(drc["id"].ToString()));
                        }
                    }
                }
            }
            return childid;
        }

        /// <summary>
        /// 获取需操作类别的父ID列表,
        /// </summary>
        public List<int> GetParentIDList(int id)
        {
            List<int> parentid = new List<int>();
            List<int> categoryid = new List<int>();
            DataSet ds = new BLL.article_publish_category().GetAllList();
            Model.article_publish_category model = new BLL.article_publish_category().GetModel(id);
            if (model.category_id > 0)
            {
                //递归获取父类别的id，article_category表中的id;
                GetParent(categoryid, model.category_id);
            }
            categoryid.Add(0);
            if (categoryid != null && categoryid.Count > 0)
            {
                for (int i = 0; i < categoryid.Count; i++)
                {
                    foreach (DataRow dr in ds.Tables[0].Rows)
                    {
                        if (dr["channel_id"].ToString() == model.channel_id.ToString() && dr["category_id"].ToString() == categoryid[i].ToString())
                        {
                            parentid.Add(int.Parse(dr["id"].ToString()));
                        }
                    }
                }
            }
            return parentid;
        }

        /// <summary>
        /// 通过ID列表获取用户组名列表
        /// </summary>
        public string GetUserGroupNameList(string UserGroupIDList)
        {
            string UserGroupNameList = "";
            if (!string.IsNullOrEmpty(UserGroupIDList))
            {
                string[] idlist = UserGroupIDList.Split(',');
                if (idlist.Length > 0)
                {
                    foreach (string id in idlist)
                    {
                        if (!string.IsNullOrEmpty(id))
                        {
                            string usergroupname = new DTcms.BLL.user_groups().GetModel(int.Parse(id)).title;
                            UserGroupNameList = UserGroupNameList + usergroupname + ",";
                        }
                    }
                    UserGroupNameList = UserGroupNameList.TrimEnd(',');
                    return UserGroupNameList;
                }
            }
            return UserGroupNameList;
        }

        private void GetParent(List<int> idlist, int thisid)
        {
            if (thisid > 0)
            {
                int tempid = new DTcms.BLL.article_category().GetModel(thisid).parent_id;
                idlist.Add(tempid);
                GetParent(idlist, tempid);
            }
        }

        /// <summary>
        /// 从内存中取得所有下级类别列表（自身迭代）
        /// </summary>
        private void GetChilds(DataTable oldData, DataTable newData, int parent_id, int channel_id, int layer)
        {
            DataRow[] dr = null;
            if (channel_id == 0)
            {
                dr = oldData.Select("parent_id=" + parent_id + " and category_id = 0");
            }
            else
            {
                if (layer == 0)
                {
                    dr = oldData.Select("parent_id=0 and category_id<>0 and channel_id = " + channel_id);
                }
                else
                {
                    dr = oldData.Select("parent_id=" + parent_id + " and channel_id = " + channel_id);
                }
            }
            for (int i = 0; i < dr.Length; i++)
            {
                //添加一行数据
                DataRow row = newData.NewRow();
                row["id"] = int.Parse(dr[i]["id"].ToString());
                row["channel_id"] = int.Parse(dr[i]["channel_id"].ToString());
                row["category_id"] = int.Parse(dr[i]["category_id"].ToString());
                row["parent_id"] = int.Parse(dr[i]["parent_id"].ToString());
                row["layer"] = int.Parse(dr[i]["layer"].ToString());
                row["title"] = dr[i]["title"].ToString();
                row["sort_id"] = int.Parse(dr[i]["sort_id"].ToString());
                row["is_allow"] = int.Parse(dr[i]["is_allow"].ToString());
                row["allow_usergroupid_list"] = dr[i]["allow_usergroupid_list"].ToString();
                row["allow_usergroupname_list"] = dr[i]["allow_usergroupname_list"].ToString();
                newData.Rows.Add(row);
                //调用自身迭代

                this.GetChilds(oldData, newData, int.Parse(dr[i]["category_id"].ToString()), int.Parse(dr[i]["channel_id"].ToString()), int.Parse(dr[i]["layer"].ToString()));

            }
        }

        #endregion  ExtensionMethod
    }
}

